unit Stack;

// simple stack for doing calculations
// - no special handling for overflow or underflow right now

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;

const
	knMaxStack = 100;


type


	TStack = class
	private
		aiStack: array[1..knMaxStack] of Integer;
		iIndex: Integer;
	public
		constructor Create;
		procedure Push(iVal: Integer);
		function Pop: Integer;
	end;

var
	stak: TStack;

// ==========================================================
implementation

{ TStack }

// ----------------------------------------------------------
// class constructor
constructor TStack.Create;
begin
	iIndex := 1;
end;

// ----------------------------------------------------------
// push a value
function TStack.Pop: Integer;
begin
	result := aiStack[iIndex];
	if iIndex > 1 then
		Dec(iIndex);
end;

// ----------------------------------------------------------
// pop a value
procedure TStack.Push(iVal: Integer);
begin
	if iIndex < knMaxStack then
		Inc(iIndex);
	aiStack[iIndex] := iVal;
end;

end.
